/*
 *  TKnobControl.h
 *  AUStk
 *
 *  Created by Airy Andr on Sun Oct 20 2002.
 *  Copyright (c) 2002 Airy Andr. All rights reserved.
 *
 */

#ifndef TKnobControl_H_
#define TKnobControl_H_

#include "TViewNoCompositingCompatible.h"

class TKnobControl
: public TViewNoCompositingCompatible
{
    friend class TViewNoCompositingCompatible;
public:
    static  CFStringRef GetControlName() { return CFSTR("knob");};
protected:
	// Contstructor/Destructor
	TKnobControl(HIViewRef inControl);
    virtual ~TKnobControl();

    virtual ControlKind		GetKind();
	
	virtual bool UseNonblockingTracking() { return true; }

    virtual OSStatus		Initialize( TCarbonEvent& inEvent );
    virtual OSStatus		StillTracking(TCarbonEvent&inEvent, HIPoint& from);
    virtual void		DrawStaticBackground(RgnHandle	inLimitRgn, CGContextRef inContext, bool  inCompositing );
    virtual void		CompatibleDraw(RgnHandle	inLimitRgn, CGContextRef inContext,bool  inCompositing );
    virtual void		TitleChanged();
    virtual void		ValueChanged();

private:
    CGImageRef mImage;
    CGImageRef mBackImage;
    float mXOffset, mYOffset; // offset for knob on background
    float mMinAngle, mMaxAngle;
};

#endif // TKnobControl