/*
 *  TPngPictControl.h
 *  AUStk
 *
 *  Created by Airy Andr on Sun Oct 20 2002.
 *  Copyright (c) 2002 Airy Andr. All rights reserved.
 *
 */

#ifndef TPngPictControl_H_
#define TPngPictControl_H_

#include "TViewNoCompositingCompatible.h"

enum {
	//! A CGImageRef that you wish displayed in the control.
	kPngPictControlCGImageTag = 'Img.'
};

class TPngPictControl
: public TViewNoCompositingCompatible
{
    friend class TViewNoCompositingCompatible;
public:
    static  CFStringRef GetControlName() { return CFSTR("pict");};
protected:
	// Contstructor/Destructor
	TPngPictControl(HIViewRef inControl);
    virtual ~TPngPictControl();

    virtual ControlKind		GetKind();

    virtual OSStatus		Initialize( TCarbonEvent& inEvent );
    virtual void		DrawStaticBackground(RgnHandle	inLimitRgn, CGContextRef inContext, bool  inCompositing );
    virtual void		CompatibleDraw(RgnHandle	inLimitRgn, CGContextRef inContext,bool  inCompositing );
    virtual void		TitleChanged();
    virtual UInt32			GetBehaviors();

	virtual OSStatus SetData(OSType inTag, ControlPartCode inPart, Size inSize, const void* inPtr);
	virtual OSStatus GetData(OSType inTag, ControlPartCode inPart, Size inSize, Size* outSize, void* inPtr);
    
private:
    CGImageRef mImage;
};

#endif // 