/*
 *  AUGUIDemoView.h
 *  CAUGuiDemo
 *
 *  Created by Airy on Wed Mar 19 2003.
 *  Copyright (c) 2003 Airy ANDRE. All rights reserved.
 *
 */

// Plugin views are based on this class
#include "AUCarbonViewNib.h"
#include "CAUGuiDemoAU.h"
#include "CAUGuiDemoCsts.h"

#define kInternalParameterProperyID 64000

// -----------------------------------------------------------------------------
// Class CAUGuiDemoAUView
//
// This class implements a GUI pane for the AUStk.
// -----------------------------------------------------------------------------
class CAUGuiDemoAUView: public CAUCarbonViewNib
{
public:
    // Construction ------------------------------
    CAUGuiDemoAUView (AudioUnitCarbonView inInstance)  : CAUCarbonViewNib(inInstance), mInternalParameters(0) {};
    // Baseclass overrides -----------------------
    CFStringRef GetBundleID() { return CFSTR("com.acme.demo.caugui"); };
	virtual bool PatchEraseRect() { return false; }

	virtual void Idle();
	virtual void FinishWindow(CFBundleRef sBundle);
    virtual void InitWindow(CFBundleRef sBundle); // Register custom controls...
	
private:
	HIViewRef mMeter[kNumInternalParameters];
	SInt32 mMeterMin[kNumInternalParameters];
	SInt32 mMeterMax[kNumInternalParameters];
	float *mInternalParameters;

};

COMPONENT_ENTRY(CAUGuiDemoAUView);
