//
//  AUGUIController.h
//  auguiCocoa
//
//  Created by Airy Andr on Sat May 29 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <AudioUnit/AudioUnit.h>
#import <AudioToolbox/AudioToolbox.h>

@class AUGUIParameterBinding;
@class AUGUIView;

@interface AUGUIController : NSController {
    AUParameterListenerRef	mParameterListener;
    
    NSMutableArray *mBindings;
    NSMutableDictionary *mParams;

    IBOutlet AUGUIView *_cocoaView;
}

#pragma mark ____ PUBLIC FUNCTIONS ____
- (AudioUnit)AU;

- (AUGUIView *)cocoaView;

- (NSMutableArray *) bindings;
- (void) setBindings: (NSArray *)newBindings;
- (AUGUIParameterBinding *) addBinding:(NSControl *)control withProperty:(NSString *)string forID:(int)paramID;

- (void)registerBinding:(AUGUIParameterBinding *)binding;
- (void)setParameter:(int)paramID fromControl:(NSControl *)control;

#pragma mark ____ PRIVATE FUNCTIONS
- (void)_synchronizeUIWithParameterValues;
- (void)_addListeners;
- (void)_removeListeners;

#pragma mark ____ LISTENER CALLBACK DISPATCHEE ____
- (void)_parameterListener:(void *)inObject parameter:(const AudioUnitParameter *)inParameter value:(Float32)inValue;

@end
