//
//  AUGUIKnob.h
//  auguiCocoa
//
//  Created by Airy Andr on Fri May 21 2004.
//  Copyright (c) 2004 Airy. All rights reserved.
//

#import <AppKit/AppKit.h>

// SEE : method exposeBinding: and the instance methods exposedBindings and valueClassForBinding:—are useful only in an Interface Builder palette.

@interface AUGUIKnobCell : NSActionCell {
    NSString *_backgroundName;
    NSString *_knobName;
    NSImage *_background;
    NSImage *_knob;
    
    double _value,_minValue, _maxValue, _minAngle, _maxAngle, _xOffset, _yOffset;
    BOOL _integralValues;
    
    double _lastTrackedValue;
}
- (void)setBackgroundName:(NSString *)name;
- (void)setKnobName:(NSString *)name;
- (void)setBackgroundImage:(NSImage *)image;
- (void)setKnobImage:(NSImage *)image;
- (NSString *)backgroundName;
- (NSString *)knobName;
- (NSImage *)background;
- (NSImage *)knob;

- (double)doubleValue;
- (double)minValue;
- (double)maxValue;
- (void)setDoubleValue:(double)val;
- (void)setMinValue:(double)min;
- (void)setMaxValue:(double)max;

- (double)minAngle;
- (double)maxAngle;
- (void)setMinAngle:(double)min;
- (void)setMaxAngle:(double)max;

- (double)xOffset;
- (double)yOffset;
- (void)setXOffset:(double)offset;
- (void)setYOffset:(double)offset;

- (BOOL)integralValues;
- (void)setIntegralValues:(BOOL)integral;
@end

@interface AUGUIKnob : NSControl {
}
+ (void)initialize;
- (void)setBackgroundName:(NSString *)name;
- (void)setKnobName:(NSString *)name;
- (void)setBackgroundImage:(NSImage *)image;
- (void)setKnobImage:(NSImage *)image;
- (NSString *)backgroundName;
- (NSString *)knobName;
- (NSImage *)background;
- (NSImage *)knob;

- (double)doubleValue;
- (float)floatValue;
- (double)value;
- (double)minValue;
- (double)maxValue;
- (void)setDoubleValue:(double)val;
- (void)setFloatValue:(float)val;
- (void)setValue:(double)val;
- (void)setMinValue:(double)min;
- (void)setMaxValue:(double)max;

- (double)minAngle;
- (double)maxAngle;
- (void)setMinAngle:(double)min;
- (void)setMaxAngle:(double)max;

- (double)xOffset;
- (double)yOffset;
- (void)setXOffset:(double)offset;
- (void)setYOffset:(double)offset;

- (BOOL)integralValues;
- (void)setIntegralValues:(BOOL)integral;
@end
