//
//  AUGUIParameterBinding.m
//  BusyPalette
//
//  Created by Airy Andr on Sat May 22 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "AUGUIParameterBinding.h"
#import "AUGUIController.h"


@implementation AUGUIParameterBinding
+ (void)initialize {
}

- (void)awakeFromNib
{
    [_controller registerBinding:self];
}

- (void)ok:(NSControl *)sender {
    [_controller setParameter:_paramID fromControl:sender];
}

- (id)init {
    [super init];
    _property = @"floatValue";
    return self;
}

- (id)initWithCoder:(NSCoder *)coder
{
    if ([coder allowsKeyedCoding]){
        _paramID = [coder decodeIntForKey:@"paramID"];
    }else{
        [coder decodeValueOfObjCType:@encode(int) at:&_paramID];
    }
    if ([coder allowsKeyedCoding]){
        _property = [coder decodeObjectForKey:@"property"];
    }else{
        _property = [coder decodeObject];
    }
    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
    
    if ([coder allowsKeyedCoding]){
        [coder encodeInt:_paramID forKey:@"paramID"];
    }else{
        [coder encodeValueOfObjCType:@encode(int) at:&_paramID];
    }
    if ([coder allowsKeyedCoding]){
        [coder encodeObject:_property forKey:@"property"];
    }else{
        [coder encodeObject:_property];
    }
}

- (id)copyWithZone:(NSZone *)zone {
    AUGUIParameterBinding *newCopy = [[AUGUIParameterBinding alloc] init];
    [newCopy setControl:_control];
    [newCopy setParamID:_paramID];
    return newCopy;
}

- (void)setProperty:(NSString*)prop
{
    [prop retain];
    if (_property)
        [_property release];
    _property = prop;
}

- (NSString*)property
{
    return _property;
}

- (void)setParamID:(int)param
{
    _paramID = param;
}

- (int)paramID
{
    return _paramID;
}

- (NSControl *)control
{
    return _control;
}

- (void)setControl:(NSControl *)control
{
    if (_control)
        [_control release];
    [control retain];
    _control = control;
}

- (AUGUIController *)controller
{
    return _controller;
}


@end
