//
//  AUGUIController.m
//  auguiCocoa
//
//  Created by Airy Andr on Sun May 30 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "AUGUIControllerInspector.h"
#import <auguiFramework/auguiFramework.h>

@implementation AUGUIControllerInspector
- init
{
    [super init];
    if ([NSBundle loadNibNamed:@"AUGUIControllerInspector" owner:self] == NO) {
        NSLog(@"Can't load AUGUIControllerInspector nib file");
    }
    return self;
}

- (void) dealloc
{
    [super dealloc];
}

- (void)ok:(id)sender
{
    AUGUIController *editedObject = [self object];
    NSApplication *app = [NSApplication sharedApplication];
    id destination = [app connectDestination];
    
    // Now fill in the details
    if ([destination isKindOfClass:[NSControl class]]) {
        NSControl *control = [app connectDestination];
        AUGUIParameterBinding *binding = [editedObject addBinding:control withProperty:@"floatValue" forID:0];
        
        NSLog(@"Connecting _control to binding");
        NSNibConnector *conn = [[NSNibOutletConnector alloc] init];
        [conn setLabel:@"_control"];
        [conn setSource:binding];
        [conn setDestination:control];
        [self addConnector:conn inUndo:NO];
        [conn release];
        NSLog([destination description]);
        
        NSLog(@"Connecting _controller to binding");
        conn = [[NSNibOutletConnector alloc] init];
        [conn setLabel:@"_controller"];
        [conn setSource:binding];
        [conn setDestination:[self object]];
        [[self inspectedDocument] addConnector:conn];
        [conn release];

        NSLog(@"Connecting control:ok: to binding");
        conn = [[NSNibControlConnector alloc] init];
        [conn setLabel:@"ok:"];
        [conn setSource:control];
        [conn setDestination:binding];
        [[self inspectedDocument] addConnector:conn];
        [conn release];
    } else if ([NSClassFromString([destination className]) isSubclassOfClass:[AUGUIView class]]) {
        NSLog(@"Connecting mView to controller");
        NSNibConnector *conn = [[NSNibOutletConnector alloc] init];
        [conn setLabel:@"_cocoaView"];
        [conn setSource:[self object]];
        [conn setDestination:destination];
        [conn establishConnection];
        [[self inspectedDocument] addConnector:conn];
        [conn release];
        NSLog([destination description]);
    } else if ([destination isKindOfClass:[NSView class]]) {
        NSLog(@"It's a NSView");
        NSLog([destination className]);
    } else {
        NSLog(@"It's what ???");
        NSLog([destination className]);
    }
    [super ok:sender];
}

- (void)revert:(id)sender
{
    NSArray *a = [[self inspectedDocument] connectorsForSource:[self object]];
    printf("Connection : %d\n", [a count]);
    int i;
    [cocoaView setStringValue:@""];
    for (i = 0; i < [a count]; ++i) {
        NSNibConnector *ib = [a objectAtIndex:i];
        NSLog([ib label]);
        if ([[ib label] compare:@"_cocoaView"] == NSOrderedSame) {
            NSLog([[ib destination] description]);
            [cocoaView setStringValue:[[ib destination] className]];
        }
    }
    [super revert:sender];
}

- (BOOL)wantsButtons
{   // IB provides OK and Revert buttons at the base of our view
    // IBInspector returns them from okButton and revertButton
    // They target the ok: and revert: methods automatically
    // See tableViewSelectionDidChange: below for more information
    // Return NO to provide your own buttons
    return YES;
}

// Adds the given connector to the document
// Undo support is enabled here
// Adds extra calls to update views, etc, if called during an undo/redo
- (void)addConnector:(id)connector
              inUndo:(BOOL)inUndo
{
    id app = [NSApplication sharedApplication];
    id doc = [app documentForObject:[connector source]];
    id editor = [doc openEditorForObject:[connector source]];
    
    [[self inspectedDocument] attachObject:[connector source] toParent:nil];
    // Add the new connection to the document
    [[self inspectedDocument] addConnector:connector];
    
    [app displayConnectionBetween:[connector source] and:[connector destination]];
    
}

@end

