/**
 *	filename: AUGUIKnob.m
 *	created : Mon Apr  2 13:32:05 2001
 *	LastEditDate Was "Tue Apr  3 08:51:36 2001"
 *
 */


#import "AUGUIKnobInspector.h"

#import "auguiFramework.h"

@implementation AUGUIKnobInspector

- init
{
    [super init];
    if ([NSBundle loadNibNamed:@"AUGUIKnobInspector" owner:self] == NO) {
        NSLog(@"Can't load AUGUIKnobInspector nib file");
    }
    return self;
}

- (void)ok:(id)sender
{
    AUGUIKnob *editedObject;
    
    editedObject = [self object];
    [editedObject setBackgroundName:[background stringValue]];
    [editedObject setKnobName:[knob stringValue]];
    [editedObject setMinValue:[min doubleValue]];
    [editedObject setMaxValue:[max doubleValue]];
    [editedObject setDoubleValue:[val doubleValue]];
    [editedObject setMinAngle:[minAngle doubleValue]];
    [editedObject setMaxAngle:[maxAngle doubleValue]];
    [editedObject setXOffset:[xOffset doubleValue]];
    [editedObject setYOffset:[yOffset doubleValue]];
    [editedObject setIntegralValues:[integral intValue]];

    // IB needs help for finding the image it seems... (thanks to Robert Grant)
    if (![editedObject background]) {
        /* Returns an array of objects conforming to the IBProjectFiles protocol
        * associated with `fileType'. */
        NSArray* resources = [[[self inspectedDocument] project]                                    
                filesForFileType: IBProjectResourcesFileType];
        
        NSImage* image = nil;
        unsigned i = 0;
        NSString* imageName = [background stringValue];
        for (i = 0; i < [resources count]; i++) {
            NSString* filename = [[[resources objectAtIndex: i] fileName] 
                stringByDeletingPathExtension];
            NSString* path = [[resources objectAtIndex: i] path];
            if ([filename isEqualToString: imageName])
                image = [[NSImage alloc] initByReferencingFile: path];
        }
        [editedObject setBackgroundImage:image];
    }
    if (![editedObject knob]) {
        /* Returns an array of objects conforming to the IBProjectFiles protocol
        * associated with `fileType'. */
        NSArray* resources = [[[self inspectedDocument] project]                                    
                filesForFileType: IBProjectResourcesFileType];
        
        NSImage* image = nil;
        unsigned i = 0;
        NSString* imageName = [knob stringValue];
        for (i = 0; i < [resources count]; i++) {
            NSString* filename = [[[resources objectAtIndex: i] fileName] 
                stringByDeletingPathExtension];
            NSString* path = [[resources objectAtIndex: i] path];
            if ([filename isEqualToString: imageName])
                image = [[NSImage alloc] initByReferencingFile: path];
        }
        [editedObject setKnobImage:image];
    }
    [super ok:sender];
}

- (void)revert:(id)sender
{
    AUGUIKnob *editedObject;
    
    editedObject = [self object];
    [background setStringValue:[editedObject backgroundName]];
    [knob setStringValue:[editedObject knobName]];
    [min setDoubleValue:[editedObject minValue]];
    [max setDoubleValue:[editedObject maxValue]];
    [val setDoubleValue:[editedObject doubleValue]];
    [minAngle setDoubleValue:[editedObject minAngle]];
    [maxAngle setDoubleValue:[editedObject maxAngle]];
    [xOffset setDoubleValue:[editedObject xOffset]];
    [yOffset setDoubleValue:[editedObject yOffset]];
    [integral setIntValue:[editedObject integralValues]];
    
    [super revert:sender];
}
@end
