/**
 *	filename: AUGUIParamInspector.m
 *	created : Thu May 31 22:34:56 2001
 *	LastEditDate Was "Sat Jun  9 19:31:43 2001"
 *
 */


#import "AUGUIParamInspector.h"

#import "auguiFramework.h"

@implementation AUGUIParamInspector

- init
{
    [super init];
    if ([NSBundle loadNibNamed:@"AUGUIParamInspector" owner:self] == NO) {
        NSLog(@"Can't load AUGUIParamInspector nib file");
    }
    return self;
}

- (void)ok:(id)sender
{
    AUGUIParameterBinding *editedObject;
    
    editedObject = [self object];
    
    /* Begin an Undo Grouping, all snapshots will be placed into the group
        * created by calling beingUndoGrouping.
        */
    [editedObject setParamID:[paramID intValue]];
    [editedObject setProperty:[property stringValue]];
    
    /* Don't forget to call super ok: calling super ok: makes sure that the
        * document is marked as being edited and lets the rest of Interface Builder
        * know that something has changed
        */
    [super ok:sender];
}

- (void)revert:(id)sender
{
    AUGUIParameterBinding *editedObject = [self object];
    [paramID setIntValue:[editedObject paramID]];
    [property setStringValue:[editedObject property]];
    /* Don't forget to call super revert: calling super revert: lets the rest of
    * Interface Builder know that something on the document has changed
    */
    [super revert:sender];
}

@end
