//
//  nibObjectKeyConnector.h
//  NSDictionary extensions framework
//
//  Copyright (c) 2002 Chris Purcell. All rights reserved.
//
//  You may use this code for whatever purposes you wish.
//  This code comes with no warranties, implied or otherwise.
//  Using it may damage your data. It shouldn't, but save a copy first.
//  That's a good idea anyway, actually.
//
//  The nibObjectKeyConnector encodes object-key links between objects
//  This is intended to allow the addition of objects to a dictionary in IB
//  The source will be the dictionary
//  The label of the link doubles as the key
//  The destination of the link is the associated object
//

#import <Foundation/Foundation.h>
#import <AppKit/NSNibConnector.h>

// New connector type to encode "object-key" link type
// Simply adds the destination object to the dictionary
// The key is the label of the link
@interface nibObjectKeyConnector : NSNibConnector {

}

@end
