//
//  nibObjectKeyConnector.m
//  NSDictionary extensions framework
//
//  Copyright (c) 2002 Chris Purcell. All rights reserved.
//
//  You may use this code for whatever purposes you wish.
//  This code comes with no warranties, implied or otherwise.
//  Using it may damage your data. It shouldn't, but save a copy first.
//  That's a good idea anyway, actually.
//
//  The nibObjectKeyConnector encodes object-key links between objects
//  This is intended to allow the addition of objects to a dictionary in IB
//  The source will be the dictionary
//  The label of the link doubles as the key
//  The destination of the link is the associated object
//

#import "nibObjectKeyConnector.h"

@implementation nibObjectKeyConnector

- (void)establishConnection
{   // This is the only method needed
    // The rest is done by the superclass and the bundle object
    [[self source] setObject:[self label]
                      forKey:[self destination]];
}

@end
